#!/bin/bash

MACADDRESS=$(/sbin/ifconfig en0|/usr/bin/grep ether|/usr/bin/awk '{print $2}')
EXTIP=$(/usr/bin/curl https://www.autohelpmate.com/cip.php)
TMAIL=$(/usr/bin/defaults read /Applications/'Mac HelpMate.app'/Contents/Resources/com.most.mhm tmail)
echo $TMAIL

OSVERS=$(/usr/bin/sw_vers -productVersion|/usr/bin/sed 's/\.//g'|/usr/bin/cut -c 1,2,3)

WARNING="[MHM-alerts] Kernel panic alert!"
BOX=$(/usr/sbin/scutil --get LocalHostName)
SMTPPATH=$(/bin/cat /etc/proactive/mailpath.txt)

checkforpanictiger ()
{

FINGERPRINT=$(/sbin/md5 -q /Library/Logs/panic.log)
EXISTS=$(/bin/ls /Library/Logs/|/usr/bin/grep -c panic.log)
if [ $EXISTS == 0 ]; then 
exit 0
fi

PREVLOG=$(/bin/ls -al /Library/Logs/|/usr/bin/grep -c .panix.txt)
UNIQUEID=$(/bin/cat /etc/proactive/id.txt)

if [ $prevlog == 0 ]; then
MAILTXT=$(/bin/cat /Library/Logs/panic.log)
MAILSUBJECT="[MHM-alerts] Kernel Panic Warning on $uniqueid"
/bin/echo Subject: $MAILSUBJECT > /tmp/houston.txt
/bin/echo >> /tmp/houston.txt
/bin/echo External IP: $EXTIP >> /tmp/houston.txt
/bin/echo Ethernet Address: $MACADDRESS >> /tmp/houston.txt
/bin/echo >> /tmp/houston.txt
/bin/echo $MAILTXT >> /tmp/houston.txt
"${SMTPPATH}" --file=/etc/proactive/msmtprc.txt < /tmp/houston.txt "$TMAIL"@machelpmates.com < /tmp/houston.txt
else
FINGERPRINT2=$(cat /Library/Logs/.panix.txt)
if [ "$FINGERPRINT" != "$FINGERPRINT2" ]; then
/bin/echo $FINGERPRINT > /Library/Logs/.panix.txt
MAILTXT=$(/bin/cat /Library/Logs/panic.log)
MAILSUBJECT="[MHM-alerts] Kernel Panic Warning on $UNIQUEID"
/bin/echo Subject: $MAILSUBJECT > /tmp/houston.txt
/bin/echo >> /tmp/houston.txt
/bin/echo External IP: $EXTIP >> /tmp/houston.txt
/bin/echo Ethernet Address: $MACADDRESS >> /tmp/houston.txt
/bin/echo >> /tmp/houston.txt
/bin/echo $MAILTXT >> /tmp/houston.txt
"${SMTPPATH}" --file=/etc/proactive/msmtprc.txt < /tmp/houston.txt "$TMAIL"@machelpmates.com < /tmp/houston.txt
fi
fi
}

checkforpanicleopard ()

{

EXISTS=$(/bin/ls -al /Library/Logs/PanicReporter|/usr/bin/grep -c "panic")

if [ $EXISTS == 0 ]; then 
exit 0
fi

PREVLOG=$(/bin/ls -al /Library/Logs/|/usr/bin/grep -c .panix.txt)
UNIQUEID=$(/bin/cat /etc/proactive/id.txt)

if [ $PREVLOG == 0 ]; then

/bin/ls -al /Library/Logs/PanicReporter > /Library/Logs/.panix.txt

/bin/rm /tmp/panicreport.txt

PANICINSTANCE=$(/bin/ls -tc /Library/Logs/PanicReporter)

for i in $PANICINSTANCE

do 

/bin/cat /Library/Logs/PanicReporter/"${i}" >> /tmp/panicreport.txt
/bin/echo " " >> /tmp/panicreport.txt

done

MAILTXT=$(/bin/cat /tmp/panicreport.txt)
MAILSUBJECT="[MHM-alerts] Kernel Panic Warning on $UNIQUEID"
/bin/echo Subject: $MAILSUBJECT > /tmp/houston.txt
/bin/echo >> /tmp/houston.txt
/bin/echo External IP: $EXTIP >> /tmp/houston.txt
/bin/echo Ethernet Address: $MACADDRESS >> /tmp/houston.txt
/bin/echo >> /tmp/houston.txt
/bin/echo $MAILTXT >> /tmp/houston.txt
"${SMTPPATH}" --file=/etc/proactive/msmtprc.txt < /tmp/houston.txt "$TMAIL"@machelpmates.com < /tmp/houston.txt

else

/bin/ls -al /Library/Logs/PanicReporter > /Library/Logs/.panix2.txt

PANICTEST=$(/usr/bin/cmp /Library/Logs/.panix.txt /Library/Logs/.panix2.txt)


if [ "$PANICTEST" != "" ]; then

echo "uh oh"

/bin/ls -al /Library/Logs/PanicReporter > /Library/Logs/.panix.txt

#generate the report text - first remove any old version

/bin/rm /tmp/panicreport.txt

PANICINSTANCE=$(/bin/ls -tc /Library/Logs/PanicReporter)

for i in $PANICINSTANCE

do 

/bin/cat /Library/Logs/PanicReporter/"${i}" >> /tmp/panicreport.txt
/bin/echo " " >> /tmp/panicreport.txt

done

MAILTXT=$(/bin/cat /tmp/panicreport.txt)
MAILSUBJECT="[MHM-alerts] Kernel Panic Warning on $UNIQUEID"
/bin/echo Subject: $MAILSUBJECT > /tmp/houston.txt
/bin/echo >> /tmp/houston.txt
/bin/echo External IP: $EXTIP >> /tmp/houston.txt
/bin/echo Ethernet Address: $MACADDRESS >> /tmp/houston.txt
/bin/echo >> /tmp/houston.txt
/bin/echo $MAILTXT >> /tmp/houston.txt
"${SMTPPATH}" --file=/etc/proactive/msmtprc.txt < /tmp/houston.txt "$TMAIL"@machelpmates.com < /tmp/houston.txt
fi
fi

}

if [ $OSVERS -ge 105 ]; then

checkforpanicleopard

else

checkforpanictiger

fi

exit 0